3126 & [kuangbin带你飞]专题一 简单搜索 F

来源:互联网 发布:电视机网络电视怎么调 编辑:程序博客网 时间:2024/05/18 03:31

F - Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

#include<iostream>#include<cstdio>#include<cstring>#include<queue>using namespace std;int prime[10005],n,m;bool book[10005];struct Node {    int ans[5];    int cnt,t;    friend bool operator < (Node a,Node b) {        return a.t>b.t;    }};void init() {    memset(prime,0,sizeof(prime));    for(int i=1001;i<=10000;i++) {        for(int j=2;j*j<=i;j++) {            if(i%j==0)  {                    prime[i]=1;                    break;            }        }    }    return ;}Node check(int x) {    Node temp;    temp.ans[0]=x/1000;    temp.ans[1]=x/100-temp.ans[0]*10;    temp.ans[2]=(x%100)/10;    temp.ans[3]=x%10;    temp.cnt=x;    temp.t=0;    return temp;}Node turn (Node now,int i,int j) {    Node next;    for(int i=0;i<4;i++)    next.ans[i]=now.ans[i];    next.t=now.t+1;    next.ans[i]=now.ans[i]+j;    next.cnt=next.ans[0]*1000+next.ans[1]*100+next.ans[2]*10+next.ans[3];    return next;}int bfs() {    memset(book,true,sizeof(book));    Node now,next;    book[n]=false;    priority_queue<Node>Q;    while(!Q.empty()) Q.pop();    now=check(n);    Q.push(now);    while(!Q.empty()) {        now=Q.top();        Q.pop();        if(now.cnt==m)  return now.t;        for(int i=0;i<4;i++) {            for(int j=-9;j<=9;j++) {                    next=turn(now,i,j);                if(((next.ans[i]>=0&&i!=0)||next.ans[i]>0)&&next.ans[i]<=9&&book[next.cnt]==true&&prime[next.cnt]==0) {                    book[next.cnt]=false;                    Q.push(next);                }            }        }    }    return -1;}int main(){    init();    int T;    cin>>T;    for(int i=0;i<T;i++){        cin>>n>>m;        int sum=bfs();        if(sum==-1) cout<<"Impossible"<<endl;        else cout<<sum<<endl;    }    return 0;}
阅读全文
0 0
原创粉丝点击